// javascript code for playing a blubbels game goes here

/*
    TODO: find bugs 
*/
/*

    Game: Main object
        GetColor(x, y)
            Returns the color of (x, y)
        GetScore
            Returns current score.
            Score = (number of  balls removed)^2
            Additional points are given when a column is emptyed (number of column)^2 * 10
        AddScore(x)
            adds score x
        GetScore(n)
            Returns score for n size of block
        GetMoveScore (n)
            Returns n*n: the score with the block of size n
        GetAdjacents (x, y)
            Returns a list of points of all the adjacent balls with the same color.
            It returns a Point object.
            If the coordinate is out of range, it returns undifined 
        SetField (fieldSize, numBubbles, undoes, addToLeft)
            fieldSize: field size
            numBubbles: number of bubbles
            undoes: number of undoes allowed
            addToLet: whether to add new column left or right
            Make a field with random values.
            Does not return anything
            

        NewGame ()
            starts a new game with previous game parameters
            
        RemoveAdjacents (stX, stY)
            It removes all the adjacent balls with the same color.
            Removing means turning the color value to -1. (Game.CellState.Empty)
            It returns number of balls removed if success.
            If selected ball does not have any same color ball around it,
            then the function alert the user and returns -1.
            If selected cell is empty, return -2
        Undo
            Undo function. Number of undoes allowed is determined when the field is set up 
            Undo Algorithm:
            Does not return anything
                1. Whenever a group of ball is removed, check whether it emptys a column.
                    this checking is done by checking field[12][12]. This cell stores whether this field
                    has one or more empty column. -10 means one, -11 means two, and so on. Baiscally,
                    -9 (offset) minus number of columns. At this point, increase the count for the
                    number of times the new columns created. Then, store the points of the board
                    at field[0][0].
                2. So, if it emptied one or more column, then using field[12][12], restore the queue
                    For, instance, if 3 columns were removed at once, field[12][12] will contain -12,
                    meaning 3 new columns were created, so I need to restore 3 times. At this point,
                    decrease the count for the number of times new columns created. Points is restored
                    at this point
                3. Now, the head of the queue will be at the same position as one step before, so
                    whenever user does same move, or different move, but creates one or more empty column,
                    the same columns will appear.
                4. If now it's time to make real new column, then check whether the size of queue and
                    number of new columns created. If they are the same, it means there is no "old next field".
                    If the size of the queue is greater than the counts, it means something was restored,
                    so I won't create new field.
        Undoable
            returns true if the player can undo a move
        GameFinished
            Returns true if the game is over, if not, returns false;


        GameEnd(0, [])
            Backtrack all state
            parameter MUST be 0 and []
            returns an object
                if the game is end:
                    .point	: max points
                    .seq	: list of move sequence (Point class)
                if the game can be imporved
                    .point      : -1
                    .seq        : []

            _moved  : Number of moves made at the point
            _points : Max point at the point
            _seq    : Move sequence that yields max point
            _prev   : go back prev state
            _next   : construct next state


    Queue: Queue class
        restore
            details on the line
        empty
            empty the array from 0 to n-1

    Point: Point class
        No comments

    KeyCtrl(e): Key down control function
        Ctrl + Z : Undo
        this function might go the front-end

    #other global functions are for debuging purposes


*/

function Queue(l) {
    var queue = new Array(l);
    var head=0, tail=0;

    this.size       = function( ) { return tail; }
        // It includes the poped ones
    this.push       = function(e) { if (tail<l) queue[tail++]=e; }
    this.pop        = function( ) { if (head<l) head++; }
    this.front      = function( ) { return queue[head]; }
    this.restore    = function( ) { if (head>0) head--; }
        // Not a normal queue function
        // It restores one last poped element
    this.empty      = function( ) {
        for (var i=0; i<tail; i++)
            queue[i] = undefined;
        head=0;
        tail=0;
    }
    this.frontFixed = function( ) { 
        return queue[head].slice(1,Game.GetFieldSize()+1);
    }
}

function Point(x, y) {
    this.x = x;
    this.y = y;
}
function Cell(x, y, col) {
    this.x = x;
    this.y = y;
    this.color = col;
}

var Game = {
    fieldSize   : 11,               // Field size
    numBubbles  : 5,                // Number of bubble types
    field       : [],               // Field; -1: empty, positive: color value
    nextFields  : new Queue(1000),  // Next field added when some columns are empty
    prevFields  : [],               // Previous fields
    addCnt      : 0,                // Counts how many times new fields are added
    points      : 0,                // Current points
    undoes      : 0,                // Number of undoes allowed
    undoed      : 0,                // Numbers of undoes done
    addToLeft   : true,             // Whether to add left or right
  
    CellState:  { Empty:-1 },
    // Values, self-explainatory
    
    AddToLeft       : function() { return this.addToLeft; },
  
    GetFieldSize    : function() { return this.fieldSize; },
    GetBubbleNum    : function() { return this.numBubbles; },
    GetColor        : function(y, x) { return this.field[x+1][y+1]; },
    SetXYColor      : function(x, y, v) { this.field[x][y] = v; },
  
    GetScore        : function()  { return this.points; },
    AddScore        : function(x) { this.points += x; },
    GetMoveScore    : function(n) { if (n<2) n=0; return n*n; },

    GetPrevField    : function() { 
        var i=this.prevFields.length-1;
        var j=this.fieldSize+1;
        if (i<0) return i;
        return this.prevFields[i][j][j];
    },
    SetPrevField    : function(v) {
        var i=this.prevFields.length-1;
        var j=this.fieldSize+1;
        this.prevFields[i][j][j] = v;
    },
    GetPrevPoint    : function() {
        return this.prevFields[this.prevFields.length-1][0][0];
    },
    SetPrevPoint    : function(v) {
        this.prevFields[this.prevFields.length-1][0][0] = v;
    },

    Undoable        : function() {
        return this.undoed<this.undoes && this.prevFields.length>0;
    },
    Undo            : function() {
        if (this.GameEnd_moved <= 0) {
            if (this.undoed >= this.undoes) return -1;
            this.undoed++;
        }

        var idx = this.prevFields.length-1;
        if (idx < 0) return -1;

 
        var col = this.GetPrevField();
        if (col <= -10) {
            col += 9;
            // no column bonus this.points -= col*col*10;
            this.addCnt += col;
            for (var i=0; i<-col; i++)
                this.nextFields.restore();
        }
        for (var i=0; i<=this.fieldSize+1; i++) 
            for (var j=0; j<=this.fieldSize+1; j++) 
                this.field[i][j] = this.prevFields[idx][i][j];
        this.points = this.GetPrevPoint();
        this.field[this.fieldSize+1][this.fieldSize+1] = this.CellState.Empty;
        this.field[0][0] = this.CellState.Empty;
        this.prevFields.pop();

        if (!this.Undoable())
          $e("undo").disabled=true;
        return 1;
    },
    
    GetAdjacents    : function(stY, stX) { // stX, stY: starting X and Y coordinate
        stX++; stY++; // Change input coordinate into game coordinate
        // First check if the coordinate is out of range
        if (stX > this.fieldSize || stY > this.fieldSize || stX < 1 || stY < 1)
            return [];
        if (this.field[stX][stY] == this.CellState.Empty)
            return [];

        var p = []; // All the adjacent points are stored here and returned
        var V = new Array(this.fieldSize+2);
        for (var i=0; i<=this.fieldSize+1; i++)
            V[i] = new Array(this.fieldSize+2);
            // To check wether V[i][j] (coordinate i,j) was visited already
        var xStack = new Array(this.fieldSize*this.fieldSize);
        var yStack = new Array(this.fieldSize*this.fieldSize);
        var idx=1; 
        
        // Initialize V array
        for (var i=1; i<=this.fieldSize; i++)
            V[i] = new Array(this.fieldSize);
        for (var i=1; i<=this.fieldSize; i++)
            for (var j=1; j<=this.fieldSize; j++)
                V[i][j] = false;
        V[stX][stY] = true;
        
        // Initialize Stacks
        xStack[idx] = stX;
        yStack[idx] = stY;
        var x,y, stColor = this.field[stX][stY]; 
        while (idx > 0)
        { // BFS
            x = xStack[idx]; y = yStack[idx]; idx--;
            p.push(new Point(y-1,x-1));
            if (this.field[x+1][y] == stColor && !V[x+1][y])
                { idx++; xStack[idx] = x+1; yStack[idx] = y;   V[x+1][y] = true; }
            if (this.field[x][y+1] == stColor && !V[x][y+1])
                { idx++; xStack[idx] = x;   yStack[idx] = y+1; V[x][y+1] = true; }
            if (this.field[x-1][y] == stColor && !V[x-1][y])
                { idx++; xStack[idx] = x-1; yStack[idx] = y;   V[x-1][y] = true; }
            if (this.field[x][y-1] == stColor && !V[x][y-1])
                { idx++; xStack[idx] = x;   yStack[idx] = y-1; V[x][y-1] = true; }
        }
        return p;
    },

    SetNextField    : function() {
        var t = [];
        var to=Math.floor(Math.random() * this.fieldSize), i;
        for (i=0; i<=to; i++)
            t.push(this.CellState.Empty);
        for (;i<=this.fieldSize; i++)
            t.push(Math.floor(Math.random() * this.numBubbles));
        t.push(this.CellState.Empty);
        this.nextFields.push(t);
    },
    
    SetField        : function(fieldSize, numBubbles, undoes, addToLeft) {
        this.Reset(fieldSize, numBubbles, undoes, addToLeft); // Reset everything first
        // Puts value for field
        this.field = new Array(this.fieldSize+2);
        for (var i=0; i<=this.fieldSize+1; i++) {
            this.field[i] = [];
            this.field[i].push(this.CellState.Empty);
            for (var j=1; j<=this.fieldSize; j++) {
              var col = Math.floor(Math.random() * this.numBubbles);
              if (col < 0 || col >= this.numBubbles) alert("?? " + col); // !!!
              this.field[i].push(col);
            }
            this.field[i].push(this.CellState.Empty);
        }
        
        for (var i=0; i<=this.fieldSize+1; i++) {
            this.field[0][i] = this.CellState.Empty;
            this.field[this.fieldSize+1][i] = this.CellState.Empty;
        }
    },

    NewGame : function() {
        //alert("setfield: " + this.fieldSize + " " + this.numBubbles + " " + this.undoes);
        this.SetField(this.fieldSize, this.numBubbles, this.undoes, this.addToLeft);
    },
  
    UpdatePrevField : function() {
        var t = new Array(this.fieldSize+2);
        for (var i=0; i<=this.fieldSize+1; i++) {
            t[i] = [];
            for (var j=0; j<=this.fieldSize+1; j++)
                t[i].push(this.field[i][j]);
        }
        this.prevFields.push(t);
    },
    
    RemoveAdjacents : function(y, x, t, c) {
        x++; y++; // Change input coordinate into game coordinate
        if (this.GameEnd_moved <= 0)
            this.undoed = Math.max(this.undoed-1,0);
        if (this.field[x][y] == this.CellState.Empty)
          return -2;

        var p = this.GetAdjacents(y-1, x-1);
        if (p.length < 2)
          return -1;
        
        this.UpdatePrevField();
      
        for (var i=0; i<p.length; i++)
            this.field[p[i].y+1][p[i].x+1] = this.CellState.Empty;
        this.SetPrevPoint(this.points);
        // no column bonus this.points += p.length*p.length;
        this.ReformField(t, c);
        return p.length;
    },
    
    IsAColumnEmpty  : function(left) { // left: true  : will start searching from left
                                       //     : false : will start searching from right
        var column=-1;
        if (left) {
            for (var i=1; i<=this.fieldSize; i++)
                if (this.field[this.fieldSize][i] == this.CellState.Empty)
                    column=i;
        }
        else {
            for (var i=this.fieldSize; i>=1; i--) 
                if (this.field[this.fieldSize][i] == this.CellState.Empty)
                    column=i;
        }  
        return column;
    },
    
    Gravity         : function(i, emptyColumn, t) {
        for (j=1; j<=this.fieldSize && i>0; j++) {
            this.field[j][emptyColumn] = this.field[j][i];
            this.field[j][i] = this.CellState.Empty;
            if (t != undefined)
               t[i-1][j-1].x = emptyColumn-1; 
        }       
    },
    AddColumn       : function(emptyColumn, c) {
        if (this.addCnt++ >= this.nextFields.size()) 
            this.SetNextField();
        for (var i=1; i<=this.fieldSize; i++)
            this.field[i][emptyColumn] = this.nextFields.front()[i];
        if (c != undefined)
            c.push(this.nextFields.frontFixed());
        this.nextFields.pop();
    },

    ReformField     : function(t, c) {
        var left = this.addToLeft;
        var inc;

        if (t != undefined) {
            for (var i=1; i<=this.fieldSize; i++) {
                for (var j=1; j<=this.fieldSize; j++) {
                    t[j-1][i-1] = new Cell(j-1, i-1, this.field[i][j]);
                }
            }
        }

        // Move everything to the bottom
        for (var i=this.fieldSize; i>1; i--) {
            for (var j=1; j<=this.fieldSize; j++) {
               if (this.field[i][j] >= 0)
                  continue;
               for (var k=i-1; k>=1; k--) {
                  if (this.field[k][j] >= 0) {
                     this.field[i][j] = this.field[k][j];
                     this.field[k][j] = this.CellState.Empty;
                     if (t != undefined)
                        t[j-1][k-1] = new Cell(j-1, i-1, this.field[i][j]);
                     break;
                  }
               }
            }
        }

        // Check if there are any empty columns, if so, move everything towards left or right
        if (left)  inc = -1;
        else       inc = 1;

        var emptyColumn = this.IsAColumnEmpty(left);
        while (emptyColumn >= 1 && emptyColumn <= this.fieldSize)
        {
            var i=emptyColumn;
            while (this.field[this.fieldSize][i] == this.CellState.Empty && i <= this.fieldSize && i >= 1)
                i+=inc;
            this.Gravity(i,emptyColumn, t);
            emptyColumn+=inc; 
        }

        emptyColumn = this.IsAColumnEmpty(left);
        if (emptyColumn >= 1 && emptyColumn <= this.fieldSize) {
            if (left) {
                this.SetPrevField(-9-emptyColumn);
                // no column bonus this.points += (emptyColumn*emptyColumn*10);
            }
            else {
                var nEmptyColumn = this.fieldSize - emptyColumn + 1;
                this.SetPrevField(-9-nEmptyColumn);
                // no column bonus this.points += (nEmptyColumn*nEmptyColumn*10);
            }
        }
        while (emptyColumn <= this.fieldSize && emptyColumn >= 1) {
            this.AddColumn(emptyColumn, c);
            emptyColumn+=inc;
        }
    },

    Reset           : function(fieldSize, numBubbles, undoes, addToLeft) {
        this.field = [];
        this.nextFields.empty();
        this.prevFields = [];
        this.addCnt = 0;
        this.points = 0;
        this.fieldSize = fieldSize;
        this.numBubbles = numBubbles;
        this.undoes = undoes;
        this.undoed = 0;
        this.addToLeft = addToLeft;
    },

    GameFinished    : function() {
        for (var i=1; i <= this.fieldSize; i++) {
            for (var j=1; j <= this.fieldSize; j++) {
                if (this.field[i][j] < 0) continue;
                if (this.field[i][j] == this.field[i+1][j]) return false;
                if (this.field[i][j] == this.field[i][j+1]) return false;
            }
        }
        return true;
    },

    BlocksLeft       : function() {
        var block = [];
        var V = new Array(this.fieldSize+2);
        var p;

        for (var i=0; i<=this.fieldSize+1; i++)
            V[i] = new Array(this.fieldSize+2);
        for (var i=1; i<=this.fieldSize; i++)
            for (var j=1; j<=this.fieldSize; j++)
                V[i][j] = 0;

        for (var i=1; i<=this.fieldSize; i++) {
            for (var j=1; j<=this.fieldSize; j++) {
                if (V[i][j] || this.field[i][j] < 0) continue;
                p = this.GetAdjacents(j-1,i-1);
                if (p.length < 2) continue;
                block.push(p);
                for (var k=0; k<p.length; k++)
                    V[p[k].y+1][p[k].x+1] = 1;
            }
        }
        return block;
    },
    

    GameEnd_moved   : 0,
    GameEnd_points  : 0,
    GameEnd_seq     : [],
    GameEnd_reset   : function(moved) {
        this.GameEnd_moved = moved;
        this.GameEnd_points = 0;
        this.GameEnd_seq = [];
    },
    GameEnd_prev    : function(seq) {
        this.Undo(); // step out
        seq.pop();
    },
    GameEnd_next    : function(x,y, seq) {
        seq.push(new Point(x,y));
        return this.GetMoveScore(this.RemoveAdjacents(x,y)); // step in
    },
    GameEnd         : function(point, seq) {
        if (point == undefined) point = 0;
        if (seq == undefined) seq = [];

        var block=this.BlocksLeft(); // # of blocks left now
        var upper_bound=4; // k
        var ret; // return valeu from recursive call
        var crtPoint; // points earn when a move is made at current state

        if (block.length > upper_bound || // if there are more than k choices or
            seq.length > upper_bound || // if the length of move seq is greater than k or
            (this.GetPrevField() < -9 && seq.length > 0)) { // if columns hava disappeared during the search
            while (seq.length > 0) // Undo everything that had happend
                this.GameEnd_prev(seq);
            return {point:-1, seq:[]}; // return -1
        }
        if (block.length <= 0) { // if there is no more block return true
            if (this.GameEnd_points < point) {
                this.GameEnd_points = point;
                while (this.GameEnd_seq.length > 0)
                    this.GameEnd_seq.pop();
                for (var i=0; i<seq.length; i++)
                    this.GameEnd_seq.push(seq[i]);
            }
            return {point:point,
                    seq:seq}; // and return 1;
        }

        for (var k=0; k<block.length; k++) {
            crtPoint = this.GameEnd_next(block[k][0].x,block[k][0].y, seq); // construct next state
            ret = this.GameEnd(point+crtPoint, seq);
            if (ret.point < 0) // if this choice leads to something that can improve
                return {point:-1, seq:[]};
            this.GameEnd_prev(seq); // if not, one back
        }
        return {point:this.GameEnd_points,
                seq:this.GameEnd_seq}; // no choice, but to finish the game
    }
}

   
function cheat2(color, column)
{
    for (var i=1; i<=Game.GetFieldSize(); i++)
        Game.SetXYColor(i,column, color);
}
function ______esterEgg() {
    setInterval( function() { 
        for (var i=1; i<=Game.GetFieldSize(); i++) {
            var to=Math.floor(Math.random() * Game.GetFieldSize()), j;
            for (j=1; j<=to; j++)
                Game.SetXYColor(j,i, Game.CellState.Empty);
            for (;j<Game.GetFieldSize(); j++)
                Game.SetXYColor(j,i, Math.floor(Math.random() * Game.GetBubbleNum()));
        }
        for (var i=0; i<=Game.GetFieldSize()+1; i++) {
            Game.SetXYColor(0,i, -1);
            Game.SetXYColor(Game.GetFieldSize()+1,i, -1);
            Game.SetXYColor(i,0, -1);
            Game.SetXYColor(i,Game.GetFieldSize()+1, -1);
        }
    }, 100);
}
