var canvas;
var aspect = 1/1;
var lineWidth = 1; // scalable
var cellWidth; // ball square
var margin; // around canvas drawing area
var popupBorder, popupPadding; 
var finishGameDX, finishGameDY;  // displacement of finishGamePopup window
var shiny = 0;
var animation = 1;
var finish = 0;    // game finished automatically
var animationDone = 1;
var endGameDone = 1;
// 7,4 also good
var size = 11; //11;
var ballTypes = 5; //5;
var prevX=-1, prevY=-1; // previous mouse coordinate
var background = "#000000";
//var colors = new Array("#808080", "#ff0000", "#00ff00", "#0000ff", "#ffff00");
var colors  = new Array("#202020", "#e00000", "#00e000", "#0000e0", "#e0e000", "#00e0e0");
var borders = new Array("#c0c0c0", "#ff0000", "#00ff00", "#0000ff", "#ffff00", "#00ffff");
// recomputed whenever size changes
var ballImages;

// canvas = lineWidth border + drawing area

// access element
function $e() {
  return document.getElementById(arguments[0]);
}

// access element value
function $ev() {
  return document.getElementById(arguments[0]).value;
}

function css(selector, property, value) {
  for (var i=0; i<document.styleSheets.length;i++) {//Loop through all styles
    //Try add rule
    try {
      document.styleSheets[i].insertRule(selector+ ' {'+property+':'+value+'}', document.styleSheets[i].cssRules.length);
    }
    catch(err) {
      try { document.styleSheets[i].addRule(selector, property+':'+value);}
      catch(err) {}
    }//IE
  }
}


function animationSetup(c)
{
  for (var i=0; i < size; i++)
    c.push(new Array(size));
  for (var i=0; i < size; i++) 
    for (var j=0; j < size; j++) 
      c[size-i-1][j] = Game.GetColor(i,j);
}

function ApplySetup()
{
  // colors reversed ...
  animation = 1;
  if ($e("animation").checked) animation = 0;
  Storage.SetAnimation(""+animation);
  
  shiny = 1;
  if ($e("shiny").checked) shiny = 0;
  Storage.SetShiny(""+shiny);

  finish = 1;
  if ($e("finish").checked) finish = 0;
  Storage.SetFinish(""+finish);
  
  //alert(animation + " " + shiny);

  resizeWindow();
}

function UpdateSetupPopup()
{
  $e("animation").checked = 0;
  if (animation == 0) {
    $e("animation").checked = 1;
  }
  
  $e("shiny").checked = 0;
  if (shiny == "0")
    $e("shiny").checked = 1;    

  $e("finish").checked = 0;
  if (finish == "0")
    $e("finish").checked = 1;

  //alert(canvas.style.left + " " + canvas.style.top);
  //alert(popupBorder + " " + popupPadding);
  //openLayerXY('gameCanvas', 'finishGamePopup', popupBorder, popupPadding, finishGameDX, finishGameDY);
}


function UpdateEndGamePopup(lastScore)
{
  var scores = Storage.LoadScore();
  var newHighScore = "Test";
  newHighScore = "";
  type = Storage.GetGameType();

  if (type == "11") {
    if(lastScore > scores.highestScoreEleven) {
      newHighScore = "New High Score!";
    }
  }
  if (type == "9") {
    if (lastScore > scores.highestScoreNine) {
      newHighScore = "New High Score!";
    }
  }
  if (type == "7") {
    if(lastScore > scores.highestScoreSeven) {
      newHighScore = "New High Score!";
    }
  }

  document.getElementById('lastScore').innerHTML = "Score: " + lastScore;
  document.getElementById('highScore').innerHTML = newHighScore;
}

function UpdateStatsPopup()
{
  var newTable = "<table border=4 cellpadding=3><tr><th>Size</th><th>Games</th><th>Best</th><th>Average</th></tr>";
  var scores = Storage.LoadScore();

  // 7
  newTable += "<tr align='center'><td>7</td>";
  newTable += "<td>" + scores.gamesPlayedSeven + "</td>";
  newTable += "<td>" + scores.highestScoreSeven + "</td>";
  
  newTable += "<td>";
  if (scores.gamesPlayedSeven > 0)
    newTable += (scores.totalScoreSeven / (scores.gamesPlayedSeven + 0.0)).toFixed(1);
  else
    newTable += "0.0";

  newTable += "</td></tr>";

  // 9
  newTable += "<tr align='center'><td>9</td>";
  newTable += "<td>" + scores.gamesPlayedNine + "</td>";
  newTable += "<td>" + scores.highestScoreNine + "</td>";
  
  newTable += "<td>";
  if (scores.gamesPlayedNine > 0)
    newTable += (scores.totalScoreNine / (scores.gamesPlayedNine + 0.0)).toFixed(1);
  else
    newTable += "0.0";
  newTable += "</td></tr>";

  // 11
  newTable += "<tr align='center'><td>11</td>";
  newTable += "<td>" + scores.gamesPlayedEleven + "</td>";
  newTable += "<td>" + scores.highestScoreEleven + "</td>";
  
  newTable += "<td>";
  if (scores.gamesPlayedEleven > 0)
    newTable += (scores.totalScoreEleven / (scores.gamesPlayedEleven + 0.0)).toFixed(1);
  else
    newTable += "0.0";
  newTable += "</td></tr>";
  
  newTable += "</table>";

  document.getElementById('statsTableDiv').innerHTML = newTable;

  /*  
  
  var newTable2 = "<table border=3 cellpadding=3><tr><th>Type</th><th>Games</th><th>Best</th><th>Average</th></tr>";
  newTable2 += "<tr align='center'><td>All</td>";
  newTable2 += "<td>" + scores.gamesPlayedNine + "</td>";
  newTable2 += "<td>" + scores.highestScoreNine + "</td>";

  newTable2 += "<td>";

  if (scores.gamesPlayedNine > 0)
    newTable2 += (scores.totalScoreNine / (scores.gamesPlayedNine + 0.0)).toFixed(1);
  else
    newTable2 += "0.0";
  
  newTable2 += "</td></tr></table>";

  document.getElementById('statsTableDiv2').innerHTML = newTable2;
  var newTable3 = "<table border=3 cellpadding=3><tr><th>Type</th><th>Games</th><th>Best</th><th>Average</th></tr>";
  newTable3 += "<tr align='center'><td>All</td>";
  newTable3 += "<td>" + scores.gamesPlayedSeven + "</td>";
  newTable3 += "<td>" + scores.highestScoreSeven + "</td>";

  
  newTable2 += "<td>";

  if (scores.gamesPlayedSeven > 0)
    newTable2 += (scores.totalScoreSeven / (scores.gamesPlayedSeven + 0.0)).toFixed(1);
  else
    newTable2 += "0.0";
  
  newTable2 += "</td></tr></table>";

  */
}

// popup window functions


// finds the position of a given object, used as reference point for our layer
function findPosition(object)
{                    
  var positionLeft = positionTop = 0;  // declare variables to store co-ordinates
  if (object.offsetParent) {         // offsetParent returns the position from the nearest element in this case our link that was clicked
    do {
      positionLeft += object.offsetLeft;      // store the position
      positionTop  += object.offsetTop;
    } while (object = object.offsetParent);
  }
  return [positionLeft, positionTop];         
}

// shows the layer and changes its position based on the parent object (center)
function openLayer(parent, myLayer, border, padding)
{
  var object = document.getElementById(parent);
  var coords = findPosition(object);  // get our co-ordinates from the findPosition function
  var layer = document.getElementById(myLayer);
  layer.style.border = border + "px solid #404040";
  layer.style.padding = padding + "px";
  layer.style.top  = ((object.height - parseInt(layer.style.height))/2 + coords[1])-(border+padding) + 'px';
  layer.style.left = ((object.width  - parseInt(layer.style.width))/2  + coords[0])-(border+padding) + 'px'; 
  layer.style.display = 'block';  // show the layer  (was display=inline
}

// shows the layer and changes its position based on the parent object +(x,y)
function openLayerXY(parent, myLayer, border, padding, x, y)
{
  var object = document.getElementById(parent);
  var coords = findPosition(object);  // get our co-ordinates from the findPosition function
  var layer = document.getElementById(myLayer);
  layer.style.border = border + "px solid #000000";
  layer.style.padding = padding + "px";
  layer.style.top  = (coords[1] + y) + 'px';
  layer.style.left = (coords[0] + x) + 'px'; 
  layer.style.display = 'block';  // show the layer  (was display=inline
}

function closeLayer(myLayer) {
  document.getElementById(myLayer).style.display='none';
}


function newGameType(type, c)
{
  // memorize selection
  Storage.SetGameType(type);

  type = Storage.GetGameType();
  
  if (type == "11") {
    size = 11;
    ballTypes = 5;
  } else if (type == "9") {
    size = 9;
    ballTypes = 4;
  } else {
    size = 7;
    ballTypes = 4;
  }
  Game.SetField(size, ballTypes, 2, true); // add from left

  if (c!=undefined)
    animationSetup(c);
  return c;
}

// generate ball images
function generateBallImages()
{
  var cellW2 = cellWidth / 2;
  var radius = 0.42 * cellWidth;
  var pxmContext = $e("pixmapCanvas").getContext("2d");

  ballImages = Array(ballTypes+1); // last one is an empty image
  
  for (var i=0; i < ballTypes; i++) {
    pxmContext.save();
    pxmContext.fillStyle = background;
    pxmContext.fillRect(0, 0, cellWidth, cellWidth);
    drawBall(i, 0, 0, cellWidth, cellW2, radius, pxmContext);
    ballImages[i] = pxmContext.getImageData(0, 0, cellWidth, cellWidth);
    pxmContext.restore();
  }
  pxmContext.save();
  pxmContext.fillStyle = background;
  pxmContext.fillRect(0, 0, cellWidth, cellWidth);
  ballImages[ballTypes] = pxmContext.getImageData(0, 0, cellWidth, cellWidth);
}


function resizeWindow() //e, t, c)
{
  SCREEN_WIDTH = window.innerWidth;
  SCREEN_HEIGHT = window.innerHeight * 0.71; // leave room for buttons and text
  canvasW = SCREEN_WIDTH;
  canvasH = SCREEN_HEIGHT;

  if (canvasW / canvasH > aspect) {
    canvasW = canvasH * aspect;
  } else {
    canvasH = canvasW / aspect;
  }

  canvas.width  = canvasW;
  canvas.height = canvasW;

  // center canvas

  var entire = document.getElementById("entire");

  entire.style.position = "absolute";
  entire.style.left = ((SCREEN_WIDTH  - canvasW) / 2) + "px";
  entire.style.top  = ((SCREEN_HEIGHT  - canvasH) / 2) + "px";

  var statsPopup = document.getElementById("statsPopup");
  statsPopup.style.position = "absolute";
  statsPopup.style.width  = (canvasW*3/4) + "px";
  statsPopup.style.height = (canvasW*3/4) + "px";  
  
  var aboutPopup = document.getElementById("aboutPopup");
  aboutPopup.style.width  = (canvasW*7/8) + "px";
  aboutPopup.style.height = (canvasW*11/10) + "px";  
  
  var gameEndPopup = document.getElementById("gameEndPopup");
  gameEndPopup.style.width  = (canvasW/2) + "px";
  gameEndPopup.style.height = (canvasW/2) + "px";
  
  var setupPopup = document.getElementById("setupPopup");
  setupPopup.style.width  = (canvasW*3/4) + "px";
  setupPopup.style.height = (canvasW*5/6) + "px";

  var finishGamePopup = document.getElementById("finishGamePopup");
  finishGamePopup.style.width  = (canvasW*6/7) + "px";
  finishGamePopup.style.height = (canvasW*1/8) + "px";

  // scale strokes
  margin = Math.ceil(canvas.width / 200);
  cellWidth = Math.round((canvas.width - 2 * margin) / size);
  // correct margin
  margin = Math.round((canvas.width - size * cellWidth) * 0.5);

  lineWidth = Math.ceil(cellWidth / 30);

  popupBorder  = canvas.width / 100;
  popupPadding = canvas.width / 100;
  finishGameDX = canvas.width / 17;
  finishGameDY = - canvas.width / 14;  
  
  // alert(canvas.width + " " + cellWidth + " " + margin);
  // 671 92 14
  
  generateBallImages();
  
  // scale fonts
  //document.body.style.fontSize = fs + "pt"; 
  document.body.style.fontSize = ((canvasW/100)*6.25)+"%";
  drawGame(); // t, c);
}

window.onload = function() 
{
  // make canvas known for easy access
  canvas = $e("gameCanvas");


  // register resize function
  window.addEventListener("resize", resizeWindow, false);
  //window.addEventListener('orientationchange', resizeWindow, false);

  canvas.addEventListener("mousedown", mouseClick, false);
  canvas.addEventListener("mousemove", mouseMove, false);

  // see https://developer.mozilla.org/en/DOM/Touch_events
  // to make touch events work
  canvas.addEventListener("touchmove", touchMove, false);
  // canvas.addEventListener("touchstart", touchStart, false);

  var type = Storage.GetGameType();

  var c=[];
  newGameType(type,c);

  animation = 0;
  if (Storage.GetAnimation() == "1")
    animation = 1;

  shiny = 0;
  if (Storage.GetShiny() == "1")
    shiny = 1;
  
  finish = 0;
  if (Storage.GetFinish() == "1")
    finish = 1;
  
  // $e("type" + type).selected = true;

  $e("undo").disabled = true;
  resizeWindow(); // undefined, [], c);
}

// return game coordinates (x,y) computed from mouse coordinates
function mouseGameCoord(e)
{
  var mouseX, mouseY;
  
  if (e.offsetX) {
    mouseX = e.offsetX;
    mouseY = e.offsetY;
  } else if (e.layerX) {
    mouseX = e.layerX;
    mouseY = e.layerY;
  }

  //console.log(mouseX + " " + mouseY);

  //var x = Math.floor((e.pageX - parseInt($e("entire").style.left) - lineWidth) / cellW);
  //var y = Math.floor((e.pageY - parseInt($e("entire").style.top)  - lineWidth) / cellW);
  var x = Math.floor((mouseX - margin) / cellWidth);
  var y = Math.floor((mouseY - margin) / cellWidth);
  if (x < 0)     x = 0;
  if (x >= size) x = size-1;
  if (y < 0)     y = 0;
  if (y >= size) y = size-1;

  return new Array(x, y);
}

// return game coordinates (x,y) computed from touchmove coordinates
function touchGameCoord(e)
{
  var mouseX, mouseY;

  mouseX = e.targetTouches[0].pageX - canvas.offsetLeft;
  mouseY = e.targetTouches[0].pageY - canvas.offsetTop;
  
  //console.log(mouseX + " " + mouseY);

  //var x = Math.floor((e.pageX - parseInt($e("entire").style.left) - lineWidth) / cellW);
  //var y = Math.floor((e.pageY - parseInt($e("entire").style.top)  - lineWidth) / cellW);
  var x = Math.floor((mouseX - margin) / cellWidth);
  var y = Math.floor((mouseY - margin) / cellWidth);
  if (x < 0)     x = 0;
  if (x >= size) x = size-1;
  if (y < 0)     y = 0;
  if (y >= size) y = size-1;

  return new Array(x, y);
}

function mouseMove(e)
{
  if (endGameDone == 0) return;
  var gc = mouseGameCoord(e);
  // if (Game.GetColor(gc[0],gc[1]) != Game.GetColor(prevX, prevY)) ||
  // if the mouse is not at the same block, 
  // or the mouse is moved diagonally
  if (gc[0] != prevX || gc[1] != prevY) {
    drawLine(prevX, prevY, true);
    drawLine(gc[0], gc[1], false);
    prevX = gc[0];
    prevY = gc[1];
  }
}

function touchMove(e)
{
  e.preventDefault();
  if (animationDone == 0 || endGameDone == 0) return;

  var gc = touchGameCoord(e);
  if (gc[0] != prevX || gc[1] != prevY) {
    drawLine(prevX, prevY, true);
    drawLine(gc[0], gc[1], false);
    prevX = gc[0];
    prevY = gc[1];
  }
}

function mouseClick(e)
{
  var t, c;

  if (animationDone == 0 || endGameDone == 0) return;

  if (animation != 0) {
    t = new Array(Game.GetFieldSize());
    for (var i=0; i<Game.GetFieldSize(); i++)
      t[i] = new Array(Game.GetFieldSize());
    c = [];
  }

  var gc = mouseGameCoord(e);

  var removed = Game.RemoveAdjacents(gc[0], gc[1], t, c);
  if (removed < 1) return;
  $e("undo").disabled=false;
  Game.AddScore(Game.GetMoveScore(removed));
  drawLine(prevX, prevY, true);  // remove outline

  function cont() {
    var delay=1000,step=0, timer;
    drawLine(gc[0], gc[1], false); // draw outline
    prevX = gc[0];
    prevY = gc[1];
    
    if (Game.GameFinished()) {
      UpdateEndGamePopup(Game.GetScore());
      Storage.NewScore(Game.GetScore(), Storage.GetGameType());
      openLayer('gameCanvas', 'gameEndPopup',  popupBorder, popupPadding);
      // rest of the code (resume()) runs when close is clicked ...
    } else { // else check whether the game is almost over
      var gameEndObj = GameEndCheck();
      if (gameEndObj != undefined) { // if it is going to be over soon

        //openLayer('gameCanvas', 'finishGamePopup');

        openLayerXY('gameCanvas', 'finishGamePopup', popupBorder, popupPadding,  finishGameDX, finishGameDY);
        
        // if (confirm("The game is over in " + len + " steps. Do you want me to finish the game for you?")) {

        c = undefined;
        endGameDone = 0;
        drawLine(gameEndObj.seq[0].x,gameEndObj.seq[0].y, false);
        
        timer = window.setInterval(function() { // do the move every 1 second
          if (step >= gameEndObj.seq.length) { // if all moves have been made, stop the timer
            endGameDone = 1;
            if (finish)
              closeLayer('finishGamePopup');
            window.clearInterval(timer);
            return;
          }
          //console.log("%d %d\n",gameEndObj.seq[step].x,gameEndObj.seq[step].y);
          var x,y, xLine,yLine;
          x = gameEndObj.seq[step].x;
          y = gameEndObj.seq[step].y;
          if (step+1 < gameEndObj.seq.length) {
            xLine = gameEndObj.seq[step+1].x;
            yLine = gameEndObj.seq[step+1].y;
          }
          
          Game.AddScore(Game.GetMoveScore(Game.RemoveAdjacents(x,y, t, c))); // remove ball
          if (animation <= 0) {
            drawGame();
          } else { // mic: added } {
            animationDone = 0;
            drawGame(t, c); // mic: use continuation?
          }
          if (step+1 < gameEndObj.seq.length)
            window.setTimeout(function(){drawLine(xLine,yLine, false);},500);
          step++; 
        }, delay);

        window.setTimeout( function() {  // after all the moves have been made, popup the score
          UpdateEndGamePopup(Game.GetScore());
          Storage.NewScore(Game.GetScore(), Storage.GetGameType());
          openLayer('gameCanvas', 'gameEndPopup',  popupBorder, popupPadding);
        }, delay*(gameEndObj.seq.length+1));
      } 
    }
  }
  
  if (animation <= 0) {
    // no animation
    drawGame();
    cont();
  } else {
    animationDone = 0;
    drawGame(t, c,    // draw the board
             cont);   // continuation when animation ends
  }
}

function GameEndCheck()
{
  if (finish == 0) {
    endGameDone = 1;
    return undefined;
  }
  
  Game.GameEnd_reset(1);
  var gameEndObj = Game.GameEnd();
  Game.GameEnd_reset(0);
  var len = gameEndObj.seq.length;
  endGameDone=0;
  if (len >= 2) {
    return gameEndObj;
  }
  endGameDone = 1;
  return undefined;
/*
  if (len >= 2) {
    $e("endGamePopup").innerHTML = "<center>" +
      "The game is over in " + len + " steps. Do you want me to finish the game for you?<br />" +
      "<button class=\"button\" onclick=\"FinishGame();\">YES</button>" +
      "<button class=\"button\" onclick=\"GoBack();\">Undo</button>" +
      "</center>";
    openLayer('gameCanvas', "endGamePopup");
  }
  function FinishGame() {
    closeLayer("endGamePopup");
    return gameEndObj;
  }
  function GoBack() {
    closeLayer("endGamePopup");
    Game.Undo();
    DrawGame();
    endGameDone=1;
    return undefined;
  }
  endGameDone=1;
*/
}

function resume()
{
  closeLayer('gameEndPopup');
  $e("undo").disabled=true;
  Game.NewGame();
  var t,c;
  if (animation != 0) {
    c=[];
    t=[];
    animationSetup(c);
  }
  drawGame(t,c); // draw the board
  prevX = prevY = -1;
}


function touchStart(e)
{
  e.preventDefault();
  var touch = e.changedTouches;
}


// game related functions

function drawBall(cont, x, y, cellW, cellW2, radius, context)
{
  var col = colors[cont];
  //console.log("col=" + Game.GetColor(x, y));
  context.lineWidth = lineWidth;
  context.beginPath();
  context.arc(x * cellW + cellW2, y * cellW + cellW2, radius, 0, 2 * Math.PI, false);

  var grd;
  if (shiny) {
    // radial gradient
    grd = context.createRadialGradient(cellW*(x+0.35),cellW*(y+0.35), 1, cellW*(x),cellW*(y),radius*2.3);
    grd.addColorStop(0.05, "#c0c0c0");

  } else {
    // linear gradient
    // which is better?
    grd = context.createLinearGradient(cellW*x,cellW*y,cellW*(x+1),cellW*(y+1));
    grd.addColorStop(0, "#d0d0d0");
  }
      
  grd.addColorStop(1, col);
  context.fillStyle = grd;
  context.fill();
  context.strokeStyle = grd;
  context.stroke();
  context.closePath();
}

// This function draws the board
// outlining the group at (selectedX, selectedY)
// (no outline if selectedX | selectedY < 0)
// if animated, cont() is called when all balls reached their locations
function drawGame(t, c, cont)
{
  var context = canvas.getContext("2d");

  context.save();

  // draw welcome text
  if (false) {
    var W = canvas.width  - 2 * margin;
    var H = canvas.height - 2 * margin;
    context.font="30px Arial";
    var text = "Welcome to Blubbels";
    var metrics = context.measureText(text);
    var tWidth = 0.65;
    sf = W * tWidth / metrics.width;
    context.scale(sf, sf);
    context.fillText(text, margin + (W * (1-tWidth) / 2)/sf, margin + (H * 0.85)/sf);
  }

  var x, y, col;

  if (t == undefined) {

    // static

    // draw background / rect on entire canvas
    context.fillStyle = background;
    context.fillRect(0, 0, canvas.width, canvas.height);

    for (y=size-1; y >= 0; y--) {
      for (x=size-1; x >= 0; x--) {
        col = Game.GetColor(x,y);
        if (col < 0) continue;
        ex = x*cellWidth + margin;
        ey = y*cellWidth + margin;
        context.putImageData(ballImages[col], ex, ey);
      }
    }
    context.restore();
    reportScore(0);
    // no continuation 
    return;
  }

  // dynamic
  var sx = new Array(2 * size * size);
  var sy = new Array(2 * size * size);
  var ex = new Array(2 * size * size);
  var ey = new Array(2 * size * size);
  var co = new Array(2 * size * size);
  var n = 0;
  
  // mic: counting down seems to help - no corruption anymore

  // draw background / rect on entire canvas
  context.fillStyle = background;
  context.fillRect(0, 0, canvas.width, canvas.height);
 
  if (t.length>0) { 
    for (x=size-1; x >= 0; x--) {
      for (y=size-1; y >= 0; y--) {
        col = t[x][y].color;
        if (col < 0) continue;

        if (x == t[x][y].x && y == t[x][y].y) {
          // no motion
          context.putImageData(ballImages[col], x*cellWidth + margin, y*cellWidth + margin);
        } else {
          context.putImageData(ballImages[col], x*cellWidth + margin, y*cellWidth + margin);
          co[n] = col;
          sx[n] = x*cellWidth + margin;
          sy[n] = y*cellWidth + margin;
          ex[n] = t[x][y].x*cellWidth + margin;
          ey[n] = t[x][y].y*cellWidth + margin;
          n++;
        }
      }
    }
  }
  if (c != undefined) {
    for (x=0; x < c.length; x++) {
      for (y=0; y < size; y++) {
        col = c[x][y];
        if (col < 0) continue;
        co[n] = col;
        sx[n] = (-x-1)*cellWidth+margin;
        sy[n] = y*cellWidth+margin;
        ex[n] = (c.length-x-1)*cellWidth+margin;
        ey[n] = y*cellWidth+margin;
        n++;
      }
    }
  }

  if (n == 0) {
    // nothing to animate
    animationDone=1;
    context.restore();
    reportScore(0);
    if (cont != null)
      cont();
    return;
  }

  // animate balls  
  var speed = cellWidth / 15;
  var accel = 1.08; 
  //var e = $e("delay");
  //var val = e.options[e.selectedIndex].value;
  //var delay = Number(val);
  var delay = 20; 
  var done = 0;

  var timer = window.setInterval( function() {
      speed *= accel;
      
      for (i=0; i < n; i++) {
        if (sx[i] < ex[i] || sy[i] < ey[i]) {
          
          context.putImageData(ballImages[ballTypes], sx[i], sy[i]);
          
          if (sx[i]+speed < ex[i]) sx[i] += speed;
          else
            sx[i] = ex[i]; // mic: this is important!
          
          if (sy[i]+speed < ey[i]) sy[i] += speed;
          else
            sy[i] = ey[i]; // mic: this is important!
          
          context.putImageData(ballImages[co[i]], sx[i], sy[i]);
          
          if (sx[i] >= ex[i] && sy[i] >= ey[i]) {
            
            done++;
            if (n == done) {
              animationDone=1;
              window.clearInterval(timer);
              context.restore();
              reportScore(0);
              if (cont != null)
                cont();
              return;
            }
          }
        }
      }
    },
    delay);
}


/*
    
function animateBall(context, sx, sy, ex, ey, col, counter, cont0, cont)
{
  var delay = 10, tmr;
  var speedx = 2, speedy = 2;
  var accel = 1.1;

  if (sx == ex && sy == ey) {
    // no animation
    context.putImageData(ballImages[col], ex, ey);
    return;
  }
  
  counter[0]++;
  
  tmr = window.setInterval( function() {
    if (sx+speedx >= ex && sy+speedy >= ey) {
      context.putImageData(ballImages[col], ex, ey);
      window.clearInterval(tmr);
      counter[1]++;
      
      if (counter[1] <= 0)
        if (cont != null)
          cont();
    }

    context.putImageData(ballImages[ballTypes], sx, sy);
    speedx *= accel;
    speedy *= accel;
    if (sx+speedx < ex) sx += speedx;
    else
      sx = ex; // mic: this is important!
    
    if (sy+speedy < ey) sy += speedy;
    else
      sy = ey; // mic: this is important!

    context.putImageData(ballImages[col], sx, sy);
  }, delay);
}

*/
     
function reportScore(move)
{
  $e("text").innerHTML = "<tt>&nbsp;&nbsp;Score " + pad(Game.GetScore(), 5) + " Move " + pad(move, 5) + "</tt>";
  
  //$e("ScoreInner").innerHTML = Game.GetScore(); 
  //$e("MoveInner").innerHTML = move;
}

function pad(num, size) {
  var s = num + "";
  var l = size - s.length;
  for (i=0; i < l; i++) {
    s += "&nbsp;";
  }
  // console.log(num + " " + size + " " + l + " '" + s + "'");
  return s;
}

function drawLine(selectedX, selectedY, doDelete)
{
  // outline group at selected location
  // doDelete : true: delete the line, false: draw the line

  if (animationDone == 0) return;

  var moveScore = 0;
  var context = canvas.getContext("2d");

  if (selectedX >= 0 && selectedY >= 0) {

    var col = Game.GetColor(selectedX, selectedY);

    if (col >= 0) { // group color != empty

      var block = Game.GetAdjacents(selectedX, selectedY);

      if (block.length > 1) {
        moveScore = Game.GetMoveScore(block.length);
      }
      
      if (doDelete) {
        context.strokeStyle = background; // background color
        context.lineWidth = lineWidth * 1.5;  // thicker line width
      } else {
        context.strokeStyle = borders[col];
        context.lineWidth = lineWidth;
      }
      for (i=0; i < block.length && block.length > 1; i++) {

        //   (x,y)
        //       \ _
        //        |_|

        var x = block[i].x;
        var y = block[i].y;
        
        // left
        if (col != Game.GetColor(x-1, y)) {
          context.beginPath();
          context.moveTo(margin + x * cellWidth, margin + y     * cellWidth);
          context.lineTo(margin + x * cellWidth, margin + (y+1) * cellWidth);
          context.closePath();
          context.stroke();
        }

        // right
        if (col != Game.GetColor(x+1, y)) {
          context.beginPath();
          context.moveTo(margin + (x+1) * cellWidth, margin + y     * cellWidth);
          context.lineTo(margin + (x+1) * cellWidth, margin + (y+1) * cellWidth);
          context.closePath();
          context.stroke();
        }

        // up
        if (col != Game.GetColor(x, y-1)) {
          context.beginPath();
          context.moveTo(margin + x     * cellWidth, margin + y * cellWidth);
          context.lineTo(margin + (x+1) * cellWidth, margin + y * cellWidth);
          context.closePath();
          context.stroke();
        }

        // down
        if (col != Game.GetColor(x, y+1)) {
          context.beginPath();
          context.moveTo(margin + x     * cellWidth, margin + (y+1) * cellWidth);
          context.lineTo(margin + (x+1) * cellWidth, margin + (y+1) * cellWidth);
          context.closePath();
          context.stroke();
        }
      }
    }
  }

  context.restore();
  
  reportScore(moveScore);
}

function test()
{
   var context = $e("pixmapCanvas").getContext("2d");

  setTimeout(alert("asdfasdf"),2000);
  var delay=1000;
  for (var i=1; i<=20; i++) setTimeout(function(){context.putImageData(ballImages[1], 5*i, 5*i);},delay*i);
}


function KeyCtrl(e)
{
  var keyCode = e.which;
  var ctrlKey = e.ctrlKey;
 
  var context = $e("pixmapCanvas").getContext("2d");

  if (ctrlKey && keyCode == 90) { // Ctrl + Z
    if (animationDone == 0 || endGameDone == 0) return false;
    Game.Undo();
    drawGame();
  }
  if (ctrlKey && keyCode == 81) { // Ctrl + Q
    if (animationDone == 0 || endGameDone == 0) return false;
    drawGame();
  }
  return true;
}

