/*

    ResetScore
      resets scores to 0

    DefineScore
      if not initialized, reset scores
      
    LoadScore
        Returns the score informations
        .gamesPlayed: number of games played
        .highestScore: highest score ever
        .totalScore: accumulated score
        Returns false if there is no score recoreded yet

    SaveScore (score)
        Saves the score


    GetGameType()
        returns saved game type

    SetGameType(type)
        sets game type

    For setup popup window:
    
    Set/GetFinish
    Set/GetShiny
    Set/GetAnimation
    
*/

var Storage = {
  ResetScores   : function()
  {
    localStorage.totalScoreEleven   = 0;
    localStorage.highestScoreEleven = 0;
    localStorage.gamesPlayedEleven  = 0;

    localStorage.totalScoreNine   = 0;
    localStorage.highestScoreNine = 0;
    localStorage.gamesPlayedNine  = 0;

    localStorage.totalScoreSeven   = 0;
    localStorage.highestScoreSeven = 0;
    localStorage.gamesPlayedSeven  = 0;
  },

  DefineScores  : function()
  {
    if (isUndefined(localStorage.totalScoreEleven) ||
        isUndefined(localStorage.totalScoreNine) ||
        isUndefined(localStorage.totalScoreSeven)) {
      this.ResetScores();
    }
  },

  LoadScore     : function()
  {
    this.DefineScores();
  
    return { gamesPlayedEleven: Number(localStorage.gamesPlayedEleven),
             gamesPlayedNine: Number(localStorage.gamesPlayedNine),
             gamesPlayedSeven: Number(localStorage.gamesPlayedSeven),
             highestScoreEleven: Number(localStorage.highestScoreEleven),
             highestScoreNine: Number(localStorage.highestScoreNine),
             highestScoreSeven: Number(localStorage.highestScoreSeven),
             totalScoreEleven: Number(localStorage.totalScoreEleven),
             totalScoreNine: Number(localStorage.totalScoreNine),
             totalScoreSeven: Number(localStorage.totalScoreSeven) };
  },

  NewScore      : function(points, gameType)
  {
    score = Number(points);
    this.DefineScores();

    if(gameType=="11"){
      localStorage.gamesPlayedEleven = Number(localStorage.gamesPlayedEleven)+1;
      localStorage.highestScoreEleven = Math.max(Number(localStorage.highestScoreEleven), score);
      localStorage.totalScoreEleven = Number(localStorage.totalScoreEleven) + score;
    }
    if(gameType=="9"){
      localStorage.gamesPlayedNine = Number(localStorage.gamesPlayedNine)+1;
      localStorage.highestScoreNine = Math.max(Number(localStorage.highestScoreNine), score);
      localStorage.totalScoreNine = Number(localStorage.totalScoreNine) + score;
    }
    if(gameType=="7"){
      localStorage.gamesPlayedSeven = Number(localStorage.gamesPlayedSeven)+1;
      localStorage.highestScoreSeven = Math.max(Number(localStorage.highestScoreSeven), score);
      localStorage.totalScoreSeven = Number(localStorage.totalScoreSeven) + score;
    }
  },

  GetGameType   : function()
  {
    var x = localStorage.gameType;

    if (isUndefined(x)) {
      x = "11"; // default value
    }
    return x;
  },

  SetGameType   : function(type)
  {
    if (type != "11" && type != "9" && type != "7") {
      // alert("illegal game type " + type);
      type = "11";
    }
    localStorage.gameType = type;
  },


  GetAnimation  : function()
  {
    var x = localStorage.animation;
    if (isUndefined(x)) {
      x = "1"; // default value
    }
    return x;
  },

  SetAnimation  : function(x)
  {
    if (x != "0" && x != "1") {
      // alert("illegal animation flag " + x);
      x = "1";
    }
  
    localStorage.animation = x;
  },

  GetShiny      : function()
  {
    var x = localStorage.shiny;
    if (isUndefined(x)) {
      x = "0"; // default value
    }
    return x;
  },

  SetShiny      : function(x)
  {
    if (x != "0" && x != "1") {
      // alert("illegal shiny flag " + x);
      x = "0";
    }
  
    localStorage.shiny = x;
  },

  GetFinish      : function()
  {
    var x = localStorage.finish;
    if (isUndefined(x)) {
      x = "1"; // default value
    }
    return x;
  },

  SetFinish      : function(x)
  {
    if (x != "0" && x != "1") {
      // alert("illegal shiny flag " + x);
      x = "0";
    }
  
    localStorage.finish = x;
  }
  
}
 
var type= Storage.GetGameType();


// hack, but == undefined/null doesn't work in firefox 13
function isUndefined(x)
{
  return x == null && x + "" == "undefined";
}

